<template>
  <q-page class="bg-grey-3">
    <q-toolbar class="bg-blue-10 text-white shadow-2">
      <q-toolbar-title class="q-ml-sm">Thành viên</q-toolbar-title>
    </q-toolbar>
    <mutate
      title="Thành viên"
      :columns="columns"
      :data="users"
      :options="mutateOptions"
      @update="updateUser"
      @delete="deleteUser"
      @table-request="getUsers"
    >
      <template slot="detail" slot-scope="props">
        <div class="detail-user">
          <div class="text-h6 q-mb-md">Xem chi tiết thành viên {{props.detail.fullName}}</div>
          <div v-for="(item, key) in props.detail" :key="key" class="user-item row justify-between">
            <div class="title">{{key | table-detail}}</div>
            <div v-if="item" class="text-right">
              <span v-if="key === 'status'">{{item | user-status}}</span>
              <span v-else-if="key === 'createdAt'">{{item | moment}}</span>
              <span v-else-if="key === 'gender'">{{item | user-gender}}</span>
              <span v-else-if="key === 'referral'">{{item.fullName}} ({{item.id}})</span>
              <span v-else-if="key === 'userRetail'">{{item | user-retail}}</span>
              <span v-else-if="key === 'medias'">
                <div class="media-wrapper">
                  <div v-for="(img, index) in item" :key="index" class="media-img">
                    <img :src="img.path" />
                  </div>
                </div>
              </span>
              <span v-else>{{item}}</span>
            </div>
            <div v-else class="text-right text-italic">Không có dữ liệu</div>
          </div>
        </div>
      </template>
      <template slot="mutation" slot-scope="props">
        <div class="row q-col-gutter-sm">
          <div class="col-12 col-md-6">
            <q-input v-model="props.data.password" type="password" outlined label="Mật khẩu mới" />
          </div>
          <div class="col-12 col-md-6">
            <q-input
              v-model="props.data.confirmPassword"
              type="password"
              outlined
              label="Xác nhận mật khẩu mới"
            />
          </div>
        </div>
      </template>
      <template slot="function" slot-scope="props">
        <q-btn
          v-if="props.row.status !== 'ACTIVE'"
          flat
          dense
          icon="verified_user"
          color="primary"
          class="q-mr-sm"
          @click="verifyUser(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Xác thực thành viên</q-tooltip>
        </q-btn>
        <q-btn
          v-if="props.row.status === 'ACTIVE' && props.row.userRetail === 'CONTRIBUTOR'"
          flat
          dense
          icon="fas fa-graduation-cap"
          color="positive"
          class="q-mr-sm"
          @click="confirmEducatedUser(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Chứng thực đã đi học</q-tooltip>
        </q-btn>
      </template>
    </mutate>
  </q-page>
</template>

<script>
import moment from 'moment';
import { mapState, mapActions } from 'vuex';
import Mutate from '~/components/commons/Mutate.vue';
import { USER_STATUS_TEXT, USER_RETAIL_TEXT } from '~/commons/enums';

export default {
  components: { Mutate },
  name: 'PageAdminCategories',
  data() {
    return {
      columns: [
        { name: 'id', label: 'ID', align: 'left', field: 'id', sortable: true },
        {
          name: 'fullName',
          label: 'Họ tên',
          align: 'left',
          field: 'fullName',
          sortable: true
        },
        {
          name: 'email',
          label: 'Email',
          align: 'left',
          field: 'email',
          sortable: true
        },
        {
          name: 'phoneNumber',
          label: 'SĐT',
          align: 'left',
          field: 'phoneNumber',
          sortable: true
        },
        {
          name: 'nationalId',
          label: 'CMND/Căn cước',
          align: 'left',
          field: 'nationalId',
          sortable: true
        },
        {
          name: 'address',
          label: 'Địa chỉ',
          align: 'left',
          field: 'fullAddress',
          sortable: true
        },
        {
          name: 'referralFk',
          label: 'Người giới thiệu',
          align: 'left',
          field: 'referral',
          sortable: true,
          format: val => (val ? `${val.fullName} (${val.id})` : '')
        },
        {
          name: 'validatorFk',
          label: 'Người duyệt xác thực',
          align: 'left',
          field: 'validator',
          sortable: true,
          format: val => (val ? `${val.fullName} (${val.id})` : '')
        },
        {
          name: 'userRetail',
          label: 'Loại hình',
          align: 'left',
          field: 'userRetail',
          sortable: true,
          format: val => USER_RETAIL_TEXT[val]
        },
        {
          name: 'createdAt',
          label: 'Ngày đăng kí',
          align: 'left',
          field: 'createdAt',
          format: val => moment(val).format('DD/MM/YYYY HH:mm:ss'),
          sortable: true
        },
        {
          name: 'status',
          label: 'Trạng thái',
          align: 'left',
          field: 'status',
          sortable: true,
          format: val => USER_STATUS_TEXT[val]
        },
        { name: 'function', align: 'right' }
      ]
    };
  },
  computed: {
    ...mapState({
      users: state => state.users.users,
      totalRows: state => state.users.totalUsers
    }),
    mutateOptions() {
      return {
        totalRows: this.totalRows
      };
    }
  },
  mounted() {
    this.getUsers();
  },
  methods: {
    ...mapActions({
      getUsers: 'users/getUsers',
      verifyUser: 'users/verifyUser',
      confirmEducatedUser: 'users/confirmEducatedUser',
      updateUser: 'users/updateUser',
      deleteUser: 'users/deleteUser'
    })
  }
};
</script>

<style lang="scss" scoped>
.detail-user {
  .user-item {
    padding: 10px;

    &:nth-child(even) {
      background-color: rgba(0, 0, 0, 0.1);
    }

    .title {
      font-weight: bold;
    }
  }
}
.media-wrapper {
  display: flex;
  flex-direction: row;
  align-items: center;
  flex-wrap: wrap;

  .media-img {
    width: 50%;
    padding: 10px;

    img {
      width: 100%;
    }
  }
}
</style>
